﻿namespace GSMock.Config
{
    using System.Configuration;

    public class CollectionsCollection : ConfigurationElementCollection
    {
        public CollectionElement this[int index]
        {
            get
            {
                return this.BaseGet(index) as CollectionElement;
            }

            set
            {
                if (this.BaseGet(index) != null)
                {
                    this.BaseRemoveAt(index);
                }
                this.BaseAdd(index, value);
            }
        }

        public CollectionElement this[string key]
        {
            get
            {
                return this.BaseGet(key) as CollectionElement;
            }
        }

        protected override ConfigurationElement CreateNewElement()
        {
            return new CollectionElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((CollectionElement)element).Name;
        }
    }
}
